var fs = require('fs');
var path = require('path');
var _ = require('underscore');
var humanize = require('humanize');

exports.stat = function(filepath) {

  var result = {
    name: path.basename(filepath),
    path: filepath,
  };

  try {
    var stat = fs.statSync(filepath);
    
    if (stat.isDirectory()) {
      result.type = 'folder';
      result.name += '/';
    } else {
      result.type = 'file';
      result.ext = path.extname(filepath).substr(1);
    }
  } catch (e) {
    console.error(e);
  }
  
  result.size = stat.size;
  result.sizeAsHuman = humanize.filesize(stat.size);

  return result;
}
